using PlcSiemens.Core.Extension;

namespace PlcSiemens.Core.Common
{
    /// <summary>
    /// 
    /// </summary>
    public static class Argument
    {
        /// <summary>
        /// ǷGuid
        /// </summary>
        /// <param name="argument">Guid</param>
        /// <param name="argumentName">Guid</param>
        /// <exception cref="ArgumentException">Ƿ</exception>
        /// <example>Argument.IsNotEmptyGuid(argument,argumentName)</example>
        public static void IsNotEmptyGuid(Guid argument, string argumentName)
        {
            if (argument.IsEmpty())
            {
                throw new ArgumentException("\"{0}\" cannot be empty guid.".FormatWith(argumentName), argumentName);
            }
        }

        /// <summary>
        /// Ƿstring
        /// </summary>
        /// <param name="argument">Guid</param>
        /// <param name="argumentName">Guid</param>
        /// <exception cref="ArgumentException">Ƿ</exception>
        /// <example>Argument.IsNotEmpty(argument,argumentName)</example>
        public static void IsNotEmpty(string argument, string argumentName)
        {
            if (argument.IsNullOrEmpty())
            {
                throw new ArgumentException("\"{0}\" cannot be blank.".FormatWith(argumentName), argumentName);
            }
        }

        /// <summary>
        /// string
        /// </summary>
        /// <param name="argument">Guid</param>
        /// <param name="length">󳤶</param>
        /// <param name="argumentName">Guid</param>
        /// <exception cref="ArgumentException">Ƿ</exception>
        /// <example>Argument.IsNotOutOfLength(argument,length,argumentName)</example>
        public static void IsNotOutOfLength(string argument, int length, string argumentName)
        {
            IsNotEmpty(argument, argumentName);
            if (argument.Trim().Length > length)
            {
                throw new ArgumentOutOfRangeException(
                    "\"{0}\" cannot be more than {1} character.".FormatWith(argumentName, length), argumentName);
            }
        }

        /// <summary>
        /// Ϊ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentNullException">Ƿ</exception>
        /// <example>Argument.IsNotNull(argument,argumentName)</example>
        public static void IsNotNull(object argument, string argumentName)
        {
            if (argument == null)
            {
                throw new ArgumentNullException(argumentName);
            }
        }

        /// <summary>
        /// intΪ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegative(argument,argumentName)</example>
        public static void IsNotNegative(int argument, string argumentName)
        {
            if (argument < 0)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// int0
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegativeOrZero(argument,argumentName)</example>
        public static void IsNotNegativeOrZero(int argument, string argumentName)
        {
            if (argument <= 0)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// longΪ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegative(argument,argumentName)</example>
        public static void IsNotNegative(long argument, string argumentName)
        {
            if (argument < 0)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// long0
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegativeOrZero(argument,argumentName)</example>
        public static void IsNotNegativeOrZero(long argument, string argumentName)
        {
            if (argument <= 0)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// floatΪ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegative(argument,argumentName)</example>
        public static void IsNotNegative(float argument, string argumentName)
        {
            if (argument < 0)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// float0
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegativeOrZero(argument,argumentName)</example>
        public static void IsNotNegativeOrZero(float argument, string argumentName)
        {
            if (argument <= 0)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// decimalΪ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegative(argument,argumentName)</example>
        public static void IsNotNegative(decimal argument, string argumentName)
        {
            if (argument < 0)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// decimal0
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegativeOrZero(argument,argumentName)</example>
        public static void IsNotNegativeOrZero(decimal argument, string argumentName)
        {
            if (argument <= 0)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// ʱǷЧ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotInvalidDate(argument,argumentName)</example>
        public static void IsNotInvalidDate(DateTime argument, string argumentName)
        {
            if (!argument.IsValid())
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// ʱ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotInPast(argument,argumentName)</example>
        public static void IsNotInPast(DateTime argument, string argumentName)
        {
            if (argument < SystemTime.Now())
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// ʱ䳬
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotInFuture(argument,argumentName)</example>
        public static void IsNotInFuture(DateTime argument, string argumentName)
        {
            if (argument > SystemTime.Now())
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// TimeSpanǷЧ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegative(argument,argumentName)</example>
        public static void IsNotNegative(TimeSpan argument, string argumentName)
        {
            if (argument < TimeSpan.Zero)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// TimeSpanǷЧ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException">Ƿ</exception>
        /// <example>Argument.IsNotNegativeOrZero(argument,argumentName)</example>
        public static void IsNotNegativeOrZero(TimeSpan argument, string argumentName)
        {
            if (argument <= TimeSpan.Zero)
            {
                throw new ArgumentOutOfRangeException(argumentName);
            }
        }

        /// <summary>
        /// ICollectionΪ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentException">Ƿ</exception>
        /// <example>Argument.IsNotEmpty(argument,argumentName)</example>
        public static void IsNotEmpty<T>(ICollection<T> argument, string argumentName)
        {
            IsNotNull(argument, argumentName);

            if (argument.Count == 0)
            {
                throw new ArgumentException("Collection cannot be empty.", argumentName);
            }
        }

        /// <summary>
        /// intֵǷ񳬳Χ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="min"></param>
        /// <param name="max"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentOutOfRangeException"></exception>
        /// <example>Argument.IsNotOutOfRange(argument,min,max,argumentName)</example>
        public static void IsNotOutOfRange(int argument, int min, int max, string argumentName)
        {
            if ((argument < min) || (argument > max))
            {
                throw new ArgumentOutOfRangeException(argumentName,
                    "{0} must be between \"{1}\"-\"{2}\".".FormatWith(argumentName, min, max));
            }
        }

        /// <summary>
        /// Ƿַ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentException"></exception>
        /// <example>Argument.IsNotOutOfRange(argument ,argumentName)</example>
        public static void IsNotInvalidEmail(string argument, string argumentName)
        {
            IsNotEmpty(argument, argumentName);

            if (!argument.IsEmail())
            {
                throw new ArgumentException("\"{0}\" is not a valid email address.".FormatWith(argumentName),
                    argumentName);
            }
        }

        /// <summary>
        /// ǷWebַ
        /// </summary>
        /// <param name="argument"></param>
        /// <param name="argumentName"></param>
        /// <exception cref="ArgumentException"></exception>
        /// <example>Argument.IsNotOutOfRange(argument ,argumentName)</example>
        public static void IsNotInvalidWebUrl(string argument, string argumentName)
        {
            IsNotEmpty(argument, argumentName);

            if (!argument.IsWebUrl())
            {
                throw new ArgumentException("\"{0}\" is not a valid web url.".FormatWith(argumentName), argumentName);
            }
        }
    }
}
