﻿namespace WCS.WorkEngineering.WebApi.Models.AGV.Request
{
    /// <summary>
    /// Agv继续执行任务请求参数
    /// </summary>
    public class ContinueTaskRequest
    {
        /// <summary>
        ///  请求编号，每个请求都要一个唯一编号， 同一个请求重复提交， 使用同一编号。
        /// </summary>
        public string reqCode { get; set; }

        /// <summary>
        ///  请求时间截 格式: “yyyy-MM-dd HH:mm:ss”。
        /// </summary>
        public string reqTime { get; set; }

        /// <summary>
        ///  客户端编号，如PDA，HCWMS等。
        /// </summary>
        public string clientCode { get; set; }

        /// <summary>
        ///  令牌号, 由调度系统颁发。
        /// </summary>
        public string tokenCode { get; set; }

        /// <summary>
        ///  工作位，与RCS-2000端配置的位置名称一致。
        /// </summary>
        public string wbCode { get; set; }

        /// <summary>
        ///  货架号，采用货架号触发的方式。
        /// </summary>
        public string podCode { get; set; }

        /// <summary>
        ///  AGV编号，采用 AGV编号触发的方式。
        /// </summary>
        public string agvCode { get; set; }

        /// <summary>
        ///  任务单号,选填, 不填系统自动生 成，必须为 64 位 UUID
        /// </summary>
        public string taskCode { get; set; }

        /// <summary>
        ///  下一个子任务的序列，指定第几个子任务开始执行，校验子任务执行是否正确。不填默认执行下一个子任务。
        /// </summary>
        public string taskSeq { get; set; }

        /// <summary>
        ///  下一个位置信息，在任务类型中配置外部设置时需要传入，否则不需要设置。待现场地图部署、配置完成后可获取
        /// </summary>
        public positionCodeClass nextPositionCode { get; set; }

        /// <summary>
        ///  根据type填写，呼叫站点/策略编号等
        /// </summary>
        public string positionCode { get; set; }

        /// <summary>
        /// 对象类型定义: 00:代表 nextPositionCode是一个位置 02:代表nextPositionCode是一个策略
        /// </summary>
        public string type { get; set; }
    }
}
