﻿using System.ComponentModel.DataAnnotations;

namespace WCS.WorkEngineering.WebApi.Models.WMS.Request
{
    /// <summary>
    ///  完成任务请求
    /// </summary>
    public class CompleteTaskRequest
    {
        /// <summary>
        /// WMS任务号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public int TaskNum { get; set; }

        /// <summary>
        /// 操作类型（1.自动完成 2.手动完成）
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public CompleteTask OperationType { get; set; }

        /// <summary>
        /// WCS操作人名称
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string WCSUpdateName { get; set; }

        /// <summary>
        /// 备用
        /// </summary>
        public string Memo1 { get; set; } = "";

        /// <summary>
        /// 备用
        /// </summary>
        public string Memo2 { get; set; } = "";
    }

    /// <summary>
    ///  完成任务类型
    /// </summary>
    public enum CompleteTask
    {
        自动完成 = 1,
        手动完成 = 2
    }
}
