﻿using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace WCS.WorkEngineering.WebApi.Models.WMS.Request
{
    public class OneFloorWorkerBuildEmptyPalletsStockRequest
    {
        /// <summary>
        ///  托盘编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string PalletCode { get; set; }

        /// <summary>
        ///  托盘类型
        /// </summary>
        public PalletType PalletType { get; set; }

        /// <summary>
        ///  入库起始地址
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string StartLoc { get; set; }

        /// <summary>
        ///  仓库编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string WareCode { get; set; }

        /// <summary>
        ///  托盘数量
        /// </summary>
        [Description("托盘数量")]
        public string PalletNum { get; set; }

        /// <summary>
        ///  大小货 1表示小货 2表示大货
        /// </summary>
        public int Height { get; set; }
    }

    /// <summary>
    ///  托盘类型
    /// </summary>
    public enum PalletType
    {
        /// <summary>
        ///  09使用的托盘
        /// </summary>
        [Description("09使用的托盘")]
        Pallet09 = 1,

        /// <summary>
        ///  非09使用的托盘
        /// </summary>
        [Description("非09使用的托盘")]
        PalletNo09 = 2,
    }
}
