﻿using System.ComponentModel;
using WCS.Core;
using WCS.Entity.Protocol.BCR;
using WCS.Entity.Protocol.Station;
using WCS.WorkEngineering.Extensions;
using DeviceFlags = WCS.WorkEngineering.Extensions.DeviceFlags;

namespace WCS.WorkEngineering.Systems
{
    /// <summary>
    ///  湿拉满轮帘线芯股第一次扫码
    /// </summary>
    //[BelongTo(typeof(SortingMainLineWorld))]
    [Description("湿拉满轮帘线芯股第一次扫码")]
    public class 湿拉满轮帘线芯股第一次扫码 : DeviceSystem<Device<IStation520, IStation521, IStation523, IBCR83>>
    {
        protected override bool ParallelDo => true;

        protected override bool SaveLogsToFile => true;

        public override void Do(Device<IStation520, IStation521, IStation523, IBCR83> obj)
        {
            var bcrCodeList = obj.Data4.GetBcrCodeList();
            //获取当前站台对应的编码信息
            //WmsApi.EnteMainLine(bcrCodeList, obj.Entity.Code);
        }

        public override bool Select(Device dev)
        {
            return dev.HasFlag(DeviceFlags.满轮主线第一次扫码);
        }
    }
}
