﻿using System.ComponentModel.DataAnnotations;

namespace WCS.WorkEngineering.WebApi.Models.WCS.Request
{
    /// <summary>
    ///  处理任务请求参数
    /// </summary>
    public class HandleTaskRequest
    {
        /// <summary>
        ///  任务号
        /// </summary>
        [Required]
        public List<int> TaskIds { get; set; }

        /// <summary>
        ///  处理类型
        /// </summary>
        [Required]
        public HandleTaskTypeEnum Type { get; set; }

        /// <summary>
        ///  用户
        /// </summary>
        public string User { get; set; }

        /// <summary>
        ///  手动处理备注
        /// </summary>
        public string ManualRemarks { get; set; }

        /// <summary>
        /// 优先级
        /// </summary>
        public int Priority { get; set; }
    }

    public enum HandleTaskTypeEnum
    {
        取消任务 = 1,
        完成任务 = 2,
        重新下发AGV任务 = 3,
        调整优先级 = 4
        //重新下发出库AGV任务 = 1,
    }
}
